use super::Street;
use crate::{errors::FejError, schema::ivago_streets::dsl::*};
use {diesel::prelude::*, PgConnection};

pub fn search_streets(db_con: &PgConnection, search_term: &str) -> Result<Vec<Street>, FejError> {
    Ok(ivago_streets
        .filter(name.ilike(format!("%{}%", search_term)))
        .or_filter(city.ilike(format!("%{}%", search_term)))
        .load(db_con)?)
}
