export interface Street {
    name: string
    city: string
}

export async function search (searchTerm: string): Promise<Street[]> {
    const baseURL = import.meta.env.VITE_ENDPOINT as string

    const r = await fetch(`${baseURL}/ivago/search?` + new URLSearchParams({
        q: searchTerm
    }))

    if (!r.ok) {
        return Promise.reject()
    }

    return r.json()
}
